/*
 * Ubiquity REST API
 * Ubiquity provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar * dogecoin * oasis * near * terra * litecoin * bitcoincash * solana  #### Testnet * bitcoin/testnet * ethereum/ropsten * dogecoin/testnet * litecoin/testnet * bitcoincash/testnet  #### Native Ubiquity provides native access to all Blockchain nodes it supports. To access native functionality, use the protocol without the v2 prefix * bitcoin/(mainnet | testnet) - [RPC Documentation](https://developer.bitcoin.org/reference/rpc/) * ethereum/(mainnet | ropsten) - [RPC Documentation](https://ethereum.org/en/developers/docs/apis/json-rpc/) * polkadot/mainnet - [Sidecar API Documentation](https://paritytech.github.io/substrate-api-sidecar/dist/) * polkadot/mainnet/http-rpc - [Polkadot RPC Documentation](https://polkadot.js.org/docs/substrate/rpc/) * algorand/mainnet - [Algod API Documentation](https://developer.algorand.org/docs/reference/rest-apis/algod/v1/) * stellar/mainnet - [Stellar Horizon API Documentation](https://developers.stellar.org/api) * dogecoin/(mainnet | testnet) - [Dogecoin API Documentaion](https://developer.bitcoin.org/reference/rpc/) * oasis/mainnet - [Oasis Rosetta Gateway Documentation](https://www.rosetta-api.org/docs/api_identifiers.html#network-identifier) * near/mainnet - [NEAR RPC Documentation](https://docs.near.org/docs/api/rpc) * terra/mainnet - [Terra RPC Documentation](https://docs.terra.money/docs/develop/how-to/endpoints.html) * litecoin/mainnet - [Litecoin RPC Documentation](https://litecoin.info/index.php/Litecoin_API) * bitcoincash/mainnet - [Bitcoin Cash RPC Documentation](https://docs.bitcoincashnode.org/doc/json-rpc/) * solana/mainnet - [Solana RPC Documentation](https://docs.solana.com/developing/clients/jsonrpc-api)  A full URL example: https://ubiquity.api.blockdaemon.com/bitcoin/mainnet  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available. 
 *
 * The version of the OpenAPI document: 2.0.0
 * Contact: support@blockdaemon.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.gitlab.blockdaemon.ubiquity.api;

import com.gitlab.blockdaemon.ubiquity.invoker.ApiCallback;
import com.gitlab.blockdaemon.ubiquity.invoker.ApiClient;
import com.gitlab.blockdaemon.ubiquity.invoker.ApiException;
import com.gitlab.blockdaemon.ubiquity.invoker.ApiResponse;
import com.gitlab.blockdaemon.ubiquity.invoker.Configuration;
import com.gitlab.blockdaemon.ubiquity.invoker.Pair;
import com.gitlab.blockdaemon.ubiquity.invoker.ProgressRequestBody;
import com.gitlab.blockdaemon.ubiquity.invoker.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.gitlab.blockdaemon.ubiquity.model.Error;
import com.gitlab.blockdaemon.ubiquity.model.FeeEstimate;
import com.gitlab.blockdaemon.ubiquity.model.SignedTx;
import com.gitlab.blockdaemon.ubiquity.model.Tx;
import com.gitlab.blockdaemon.ubiquity.model.TxConfirmation;
import com.gitlab.blockdaemon.ubiquity.model.TxPage;
import com.gitlab.blockdaemon.ubiquity.model.TxReceipt;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TransactionsApi {
    private ApiClient localVarApiClient;

    public TransactionsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public TransactionsApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for estimateFee
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param confirmedWithinBlocks The number of blocks you would like the transaction to be processed within. Lower numbers produce higher fees.  (optional, default to 10)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> A fee estimation from bitcoin (satoshis) </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call estimateFeeCall(String platform, String network, Integer confirmedWithinBlocks, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/v2/{platform}/{network}/tx/estimate_fee"
            .replaceAll("\\{" + "platform" + "\\}", localVarApiClient.escapeString(platform.toString()))
            .replaceAll("\\{" + "network" + "\\}", localVarApiClient.escapeString(network.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (confirmedWithinBlocks != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("confirmed_within_blocks", confirmedWithinBlocks));
        }

        final String[] localVarAccepts = {
            "text/plain", "application/json", "application/problem+json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call estimateFeeValidateBeforeCall(String platform, String network, Integer confirmedWithinBlocks, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'platform' is set
        if (platform == null) {
            throw new ApiException("Missing the required parameter 'platform' when calling estimateFee(Async)");
        }
        
        // verify the required parameter 'network' is set
        if (network == null) {
            throw new ApiException("Missing the required parameter 'network' when calling estimateFee(Async)");
        }
        

        okhttp3.Call localVarCall = estimateFeeCall(platform, network, confirmedWithinBlocks, _callback);
        return localVarCall;

    }

    /**
     * Get fee estimate
     * Get a fee estimation in decimals from the network. If supported by the platform, the number of blocks used to make the estimation can be customized by the confirmed_within_blocks query parameter. 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param confirmedWithinBlocks The number of blocks you would like the transaction to be processed within. Lower numbers produce higher fees.  (optional, default to 10)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> A fee estimation from bitcoin (satoshis) </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
     </table>
     */
    public String estimateFee(String platform, String network, Integer confirmedWithinBlocks) throws ApiException {
        ApiResponse<String> localVarResp = estimateFeeWithHttpInfo(platform, network, confirmedWithinBlocks);
        return localVarResp.getData();
    }

    /**
     * Get fee estimate
     * Get a fee estimation in decimals from the network. If supported by the platform, the number of blocks used to make the estimation can be customized by the confirmed_within_blocks query parameter. 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param confirmedWithinBlocks The number of blocks you would like the transaction to be processed within. Lower numbers produce higher fees.  (optional, default to 10)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> A fee estimation from bitcoin (satoshis) </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<String> estimateFeeWithHttpInfo(String platform, String network, Integer confirmedWithinBlocks) throws ApiException {
        okhttp3.Call localVarCall = estimateFeeValidateBeforeCall(platform, network, confirmedWithinBlocks, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get fee estimate (asynchronously)
     * Get a fee estimation in decimals from the network. If supported by the platform, the number of blocks used to make the estimation can be customized by the confirmed_within_blocks query parameter. 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param confirmedWithinBlocks The number of blocks you would like the transaction to be processed within. Lower numbers produce higher fees.  (optional, default to 10)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> A fee estimation from bitcoin (satoshis) </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call estimateFeeAsync(String platform, String network, Integer confirmedWithinBlocks, final ApiCallback<String> _callback) throws ApiException {

        okhttp3.Call localVarCall = estimateFeeValidateBeforeCall(platform, network, confirmedWithinBlocks, _callback);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for feeEstimate
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Platforms overview </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call feeEstimateCall(String platform, String network, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/v1/{platform}/{network}/tx/estimate_fee"
            .replaceAll("\\{" + "platform" + "\\}", localVarApiClient.escapeString(platform.toString()))
            .replaceAll("\\{" + "network" + "\\}", localVarApiClient.escapeString(network.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call feeEstimateValidateBeforeCall(String platform, String network, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'platform' is set
        if (platform == null) {
            throw new ApiException("Missing the required parameter 'platform' when calling feeEstimate(Async)");
        }
        
        // verify the required parameter 'network' is set
        if (network == null) {
            throw new ApiException("Missing the required parameter 'network' when calling feeEstimate(Async)");
        }
        

        okhttp3.Call localVarCall = feeEstimateCall(platform, network, _callback);
        return localVarCall;

    }

    /**
     * Get fee estimate
     * Get a fee estimation in decimals from the ubiquity fee estimation service. Currently supported for Bitcoin and Ethereum. Endpoint will return 3 fee estimations fast, medium and slow 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @return FeeEstimate
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Platforms overview </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public FeeEstimate feeEstimate(String platform, String network) throws ApiException {
        ApiResponse<FeeEstimate> localVarResp = feeEstimateWithHttpInfo(platform, network);
        return localVarResp.getData();
    }

    /**
     * Get fee estimate
     * Get a fee estimation in decimals from the ubiquity fee estimation service. Currently supported for Bitcoin and Ethereum. Endpoint will return 3 fee estimations fast, medium and slow 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @return ApiResponse&lt;FeeEstimate&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Platforms overview </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<FeeEstimate> feeEstimateWithHttpInfo(String platform, String network) throws ApiException {
        okhttp3.Call localVarCall = feeEstimateValidateBeforeCall(platform, network, null);
        Type localVarReturnType = new TypeToken<FeeEstimate>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get fee estimate (asynchronously)
     * Get a fee estimation in decimals from the ubiquity fee estimation service. Currently supported for Bitcoin and Ethereum. Endpoint will return 3 fee estimations fast, medium and slow 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Platforms overview </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call feeEstimateAsync(String platform, String network, final ApiCallback<FeeEstimate> _callback) throws ApiException {

        okhttp3.Call localVarCall = feeEstimateValidateBeforeCall(platform, network, _callback);
        Type localVarReturnType = new TypeToken<FeeEstimate>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getTx
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param id Transaction ID/Hash (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transaction </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTxCall(String platform, String network, String id, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/v2/{platform}/{network}/tx/{id}"
            .replaceAll("\\{" + "platform" + "\\}", localVarApiClient.escapeString(platform.toString()))
            .replaceAll("\\{" + "network" + "\\}", localVarApiClient.escapeString(network.toString()))
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/problem+json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getTxValidateBeforeCall(String platform, String network, String id, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'platform' is set
        if (platform == null) {
            throw new ApiException("Missing the required parameter 'platform' when calling getTx(Async)");
        }
        
        // verify the required parameter 'network' is set
        if (network == null) {
            throw new ApiException("Missing the required parameter 'network' when calling getTx(Async)");
        }
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getTx(Async)");
        }
        

        okhttp3.Call localVarCall = getTxCall(platform, network, id, _callback);
        return localVarCall;

    }

    /**
     * Transaction By Hash
     * 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param id Transaction ID/Hash (required)
     * @return Tx
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transaction </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public Tx getTx(String platform, String network, String id) throws ApiException {
        ApiResponse<Tx> localVarResp = getTxWithHttpInfo(platform, network, id);
        return localVarResp.getData();
    }

    /**
     * Transaction By Hash
     * 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param id Transaction ID/Hash (required)
     * @return ApiResponse&lt;Tx&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transaction </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Tx> getTxWithHttpInfo(String platform, String network, String id) throws ApiException {
        okhttp3.Call localVarCall = getTxValidateBeforeCall(platform, network, id, null);
        Type localVarReturnType = new TypeToken<Tx>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Transaction By Hash (asynchronously)
     * 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param id Transaction ID/Hash (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transaction </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTxAsync(String platform, String network, String id, final ApiCallback<Tx> _callback) throws ApiException {

        okhttp3.Call localVarCall = getTxValidateBeforeCall(platform, network, id, _callback);
        Type localVarReturnType = new TypeToken<Tx>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getTxConfirmations
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param id Transaction ID/Hash (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transaction confirmations </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTxConfirmationsCall(String platform, String network, String id, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/v1/{platform}/{network}/tx/{id}/confirmations"
            .replaceAll("\\{" + "platform" + "\\}", localVarApiClient.escapeString(platform.toString()))
            .replaceAll("\\{" + "network" + "\\}", localVarApiClient.escapeString(network.toString()))
            .replaceAll("\\{" + "id" + "\\}", localVarApiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/problem+json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getTxConfirmationsValidateBeforeCall(String platform, String network, String id, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'platform' is set
        if (platform == null) {
            throw new ApiException("Missing the required parameter 'platform' when calling getTxConfirmations(Async)");
        }
        
        // verify the required parameter 'network' is set
        if (network == null) {
            throw new ApiException("Missing the required parameter 'network' when calling getTxConfirmations(Async)");
        }
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getTxConfirmations(Async)");
        }
        

        okhttp3.Call localVarCall = getTxConfirmationsCall(platform, network, id, _callback);
        return localVarCall;

    }

    /**
     * Transaction confirmations By Hash
     * 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param id Transaction ID/Hash (required)
     * @return TxConfirmation
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transaction confirmations </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public TxConfirmation getTxConfirmations(String platform, String network, String id) throws ApiException {
        ApiResponse<TxConfirmation> localVarResp = getTxConfirmationsWithHttpInfo(platform, network, id);
        return localVarResp.getData();
    }

    /**
     * Transaction confirmations By Hash
     * 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param id Transaction ID/Hash (required)
     * @return ApiResponse&lt;TxConfirmation&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transaction confirmations </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<TxConfirmation> getTxConfirmationsWithHttpInfo(String platform, String network, String id) throws ApiException {
        okhttp3.Call localVarCall = getTxConfirmationsValidateBeforeCall(platform, network, id, null);
        Type localVarReturnType = new TypeToken<TxConfirmation>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Transaction confirmations By Hash (asynchronously)
     * 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param id Transaction ID/Hash (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transaction confirmations </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTxConfirmationsAsync(String platform, String network, String id, final ApiCallback<TxConfirmation> _callback) throws ApiException {

        okhttp3.Call localVarCall = getTxConfirmationsValidateBeforeCall(platform, network, id, _callback);
        Type localVarReturnType = new TypeToken<TxConfirmation>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getTxs
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param order Pagination order (optional)
     * @param continuation Continuation token from earlier response (optional)
     * @param limit Max number of items to return in a response. Defaults to 25 and is capped at 100.  (optional)
     * @param assets Comma-separated list of asset paths to filter. If the list is empty, or all elements are empty, this filter has no effect. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transactions </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Invalid continuation </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTxsCall(String platform, String network, String order, String continuation, Integer limit, String assets, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/v2/{platform}/{network}/txs"
            .replaceAll("\\{" + "platform" + "\\}", localVarApiClient.escapeString(platform.toString()))
            .replaceAll("\\{" + "network" + "\\}", localVarApiClient.escapeString(network.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (order != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("order", order));
        }

        if (continuation != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("continuation", continuation));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        if (assets != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("assets", assets));
        }

        final String[] localVarAccepts = {
            "application/json", "application/problem+json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getTxsValidateBeforeCall(String platform, String network, String order, String continuation, Integer limit, String assets, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'platform' is set
        if (platform == null) {
            throw new ApiException("Missing the required parameter 'platform' when calling getTxs(Async)");
        }
        
        // verify the required parameter 'network' is set
        if (network == null) {
            throw new ApiException("Missing the required parameter 'network' when calling getTxs(Async)");
        }
        

        okhttp3.Call localVarCall = getTxsCall(platform, network, order, continuation, limit, assets, _callback);
        return localVarCall;

    }

    /**
     * All Transactions
     * Get all transactions on the platform, starting with the lastest one. Each call returns a slice of the entire list. Use the returned continuation token to get the next part.
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param order Pagination order (optional)
     * @param continuation Continuation token from earlier response (optional)
     * @param limit Max number of items to return in a response. Defaults to 25 and is capped at 100.  (optional)
     * @param assets Comma-separated list of asset paths to filter. If the list is empty, or all elements are empty, this filter has no effect. (optional)
     * @return TxPage
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transactions </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Invalid continuation </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public TxPage getTxs(String platform, String network, String order, String continuation, Integer limit, String assets) throws ApiException {
        ApiResponse<TxPage> localVarResp = getTxsWithHttpInfo(platform, network, order, continuation, limit, assets);
        return localVarResp.getData();
    }

    /**
     * All Transactions
     * Get all transactions on the platform, starting with the lastest one. Each call returns a slice of the entire list. Use the returned continuation token to get the next part.
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param order Pagination order (optional)
     * @param continuation Continuation token from earlier response (optional)
     * @param limit Max number of items to return in a response. Defaults to 25 and is capped at 100.  (optional)
     * @param assets Comma-separated list of asset paths to filter. If the list is empty, or all elements are empty, this filter has no effect. (optional)
     * @return ApiResponse&lt;TxPage&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transactions </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Invalid continuation </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<TxPage> getTxsWithHttpInfo(String platform, String network, String order, String continuation, Integer limit, String assets) throws ApiException {
        okhttp3.Call localVarCall = getTxsValidateBeforeCall(platform, network, order, continuation, limit, assets, null);
        Type localVarReturnType = new TypeToken<TxPage>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * All Transactions (asynchronously)
     * Get all transactions on the platform, starting with the lastest one. Each call returns a slice of the entire list. Use the returned continuation token to get the next part.
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param order Pagination order (optional)
     * @param continuation Continuation token from earlier response (optional)
     * @param limit Max number of items to return in a response. Defaults to 25 and is capped at 100.  (optional)
     * @param assets Comma-separated list of asset paths to filter. If the list is empty, or all elements are empty, this filter has no effect. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Transactions </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Invalid continuation </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTxsAsync(String platform, String network, String order, String continuation, Integer limit, String assets, final ApiCallback<TxPage> _callback) throws ApiException {

        okhttp3.Call localVarCall = getTxsValidateBeforeCall(platform, network, order, continuation, limit, assets, _callback);
        Type localVarReturnType = new TypeToken<TxPage>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for txSend
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param signedTx  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> A submitted Transaction ID </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call txSendCall(String platform, String network, SignedTx signedTx, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = signedTx;

        // create path and map variables
        String localVarPath = "/v2/{platform}/{network}/tx/send"
            .replaceAll("\\{" + "platform" + "\\}", localVarApiClient.escapeString(platform.toString()))
            .replaceAll("\\{" + "network" + "\\}", localVarApiClient.escapeString(network.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json", "application/problem+json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call txSendValidateBeforeCall(String platform, String network, SignedTx signedTx, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'platform' is set
        if (platform == null) {
            throw new ApiException("Missing the required parameter 'platform' when calling txSend(Async)");
        }
        
        // verify the required parameter 'network' is set
        if (network == null) {
            throw new ApiException("Missing the required parameter 'network' when calling txSend(Async)");
        }
        
        // verify the required parameter 'signedTx' is set
        if (signedTx == null) {
            throw new ApiException("Missing the required parameter 'signedTx' when calling txSend(Async)");
        }
        

        okhttp3.Call localVarCall = txSendCall(platform, network, signedTx, _callback);
        return localVarCall;

    }

    /**
     * Submit a signed transaction
     * Submit a signed transaction to the network.  **Note**: A successful transaction may still be rejected on chain or not processed due to a too low fee. You can monitor successful transactions through Ubiquity websockets. 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param signedTx  (required)
     * @return TxReceipt
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> A submitted Transaction ID </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
     </table>
     */
    public TxReceipt txSend(String platform, String network, SignedTx signedTx) throws ApiException {
        ApiResponse<TxReceipt> localVarResp = txSendWithHttpInfo(platform, network, signedTx);
        return localVarResp.getData();
    }

    /**
     * Submit a signed transaction
     * Submit a signed transaction to the network.  **Note**: A successful transaction may still be rejected on chain or not processed due to a too low fee. You can monitor successful transactions through Ubiquity websockets. 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param signedTx  (required)
     * @return ApiResponse&lt;TxReceipt&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> A submitted Transaction ID </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<TxReceipt> txSendWithHttpInfo(String platform, String network, SignedTx signedTx) throws ApiException {
        okhttp3.Call localVarCall = txSendValidateBeforeCall(platform, network, signedTx, null);
        Type localVarReturnType = new TypeToken<TxReceipt>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Submit a signed transaction (asynchronously)
     * Submit a signed transaction to the network.  **Note**: A successful transaction may still be rejected on chain or not processed due to a too low fee. You can monitor successful transactions through Ubiquity websockets. 
     * @param platform Coin platform handle (required)
     * @param network Which network to target. Available networks can be found with /{platform} (required)
     * @param signedTx  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> A submitted Transaction ID </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Invalid or expired token </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Rate limit exceeded </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> Bad Request </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call txSendAsync(String platform, String network, SignedTx signedTx, final ApiCallback<TxReceipt> _callback) throws ApiException {

        okhttp3.Call localVarCall = txSendValidateBeforeCall(platform, network, signedTx, _callback);
        Type localVarReturnType = new TypeToken<TxReceipt>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
